///////////////////////////////////////////////////////////////////////////////////////////////////
//         glibPlatformException.cpp
///////////////////////////////////////////////////////////////////////////////////////////////////

/*! \class        glibPlatformException.cpp
*  \brief        <brief description> 
*                <long description> 
*  \version      1.0 
*  \date         15.12.2004
*  \author       responsible: [kt]
*/



///////////////////////////////////////////////////////////////////////////////////////////////////
/*!	\fn          char* glibPlatformException::GetExceptionDescription(glibExcepionType  eExceptionCode); 
*	
*   \param       glibExcepionType  eExceptionCode
*   \return      const char* 
*   \note        
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
const char* glibPlatformException::GetExceptionDescription(glibExcepionType  eExceptionCode)
{

	switch(eExceptionCode) {
	
	// this is another example of a ListGen substitution. Again: the code between the two ListGen 
	// tags will be lost and re-written each time ListGen processes the file.

	//$$%%$$%%pattern>>>> exceptions tostring
	//---------------------------------------------------------------------------------------------
	// Section: Special purpose  
	//---------------------------------------------------------------------------------------------

	// special  
	case glibExcepionType_UNKNOWN:return "unknown exception."; 
	case glibExcepionType_Reraised:return "Exception was thrown again after being handled."; 
	case glibExcepionType_MS_VCPP_THROW:return "A Microsoft Visual c++ Exception was thrown using throw(), but not basically handled."; 


	//---------------------------------------------------------------------------------------------
	// Section: Hardware exceptions  
	//---------------------------------------------------------------------------------------------

	// Memory  
	case glibExcepionType_MEM_AccessViolation:return "Memory access violation."; 
	case glibExcepionType_MEM_MisalignedAccess:return "Memory Misaligned Access."; 


	// Arithmetic		  
	case glibExcepionType_ARITH_DivisionByZero:return "ARITHMETIC: Division by Zero."; 
	case glibExcepionType_ARITH_Overflow:return "ARITHMETIC: Overflow."; 


	// Instruction set		  
	case glibExcepionType_CPU_IllegalInstruction:return "CPU: Illegal instruction."; 
	case glibExcepionType_CPU_PrivilegedInstruction:return "CPU: Privileged Instruction."; 


	// Debugging		  
	case glibExcepionType_DEBUG_Breakpoint:return "DEBUG: Breakpoint hit (inline interrupt ??)."; 
	case glibExcepionType_DEBUG_Singlestep:return "DEBUG: Single step instruction."; 


	//---------------------------------------------------------------------------------------------
	// Section: Glibs		  
	//---------------------------------------------------------------------------------------------

	// Memory  
	case glibExcepionType_GLIB_MEM_OutOfMemory:return "GLIBS[GEN]: Out Of Memory."; 
	case glibExcepionType_GLIB_MEM_NullpointerAtDelete:return "GLIBS[GEN]: Null pointer specified at delete."; 
	case glibExcepionType_GLIB_MEM_ConstructionOfNullObj:return "GLIBS[GEN]: Construction of NULL Object."; 
	case glibExcepionType_GLIB_MEM_DeletingNullObj:return "GLIBS[GEN]: Deletation of NULL Object."; 
	case glibExcepionType_GLIB_MEM_WrongAlignment:return "GLIBS[GEN]: Wrong alignment specified for memblock. Must be power of 2 from 1 to 256."; 
	case glibExcepionType_GLIB_MEM_MemCategoryNotLocked:return "GLIBS[GEN]: Memory categories was not locked during statistics access."; 
	case glibExcepionType_GLIB_MEM_FileInfoStackOverflow:return "GLIBS[GEN]: Overflow of file info stack (mem logging). Increase GLIB_MEM_MAX_FILEINFO_STACK_SIZE !"; 
	case glibExcepionType_GLIB_MEM_FileInfoStackUnderflow:return "GLIBS[GEN]: Underflow of file info stack (mem logging)."; 


	// Thread management		  
	case glibExcepionType_GLIB_THREAD_IllegalThreadId:return "GLIBS[THREAD]: Illegal Thread Id."; 
	case glibExcepionType_GLIB_THREAD_NoMutex:return "GLIBS[THREAD]: Mutex in Thread Manager missing."; 
	case glibExcepionType_GLIB_THREAD_InterfaceMissing:return "GLIBS[THREAD]: Interface missing for thread. Cannot run."; 


	// Logger		  
	case glibExcepionType_GLIB_LOGGER_IllegalCall:return "GLIBS[LOGGER]: Illegal call. Unregistered Thread May not call Logging function."; 
	case glibExcepionType_GLIB_LOGGER_ContextNotFound:return "GLIBS[LOGGER]: Logging context was not found."; 
	case glibExcepionType_GLIB_LOGGER_ContextStackOverflow:return "GLIBS[LOGGER]: Logging stack overflow."; 
	case glibExcepionType_GLIB_LOGGER_ContextStackUnderflow:return "GLIBS[LOGGER]: Logging stack underflow."; 


	// Debugging		  
	case glibExcepionType_GLIB_DEBUG_AssertionFailed:return "GLIBS[DEBUG]: Assertion Failed."; 
	case glibExcepionType_GLIB_DEBUG_Error:return "GLIBS[DEBUG]: General Error."; 
	case glibExcepionType_GLIB_DEBUG_Warning:return "GLIBS[DEBUG]: General Warning."; 
	case glibExcepionType_GLIB_DEBUG_Info:return "GLIBS[DEBUG]: General Info."; 
	case glibExcepionType_GLIB_DEBUG_Note:return "GLIBS[DEBUG]: General Note."; 
	case glibExcepionType_GLIB_DEBUG_Message:return "GLIBS[DEBUG]: General Message."; 
	case glibExcepionType_GLIB_DEBUG_FailAssert:return "GLIBS[DEBUG]: Assertion Failed."; 


	// File System		  
	case glibExcepionType_GLIB_FILE_CannotOpen:return "GLIBS[FILE]: Unable to open file."; 
	case glibExcepionType_GLIB_FILE_UnexceptedEnd:return "GLIBS[FILE]: Unexpecet end of file."; 
	case glibExcepionType_GLIB_FILE_FormatError:return "GLIBS[FILE]: Wrong file Format."; 


	// Parser		  
	case glibExcepionType_GLIB_PARSE_Error:return "GLIBS[PARSE]: General parsing error."; 
	case glibExcepionType_GLIB_PARSE_Warning:return "GLIBS[PARSE]: Fatal parsing warning."; 
	case glibExcepionType_GLIB_PARSE_BadFormat:return "GLIBS[PARSE]: Bad Format."; 
	case glibExcepionType_GLIB_PARSE_BadTag:return "GLIBS[PARSE]: Bad Tag."; 
	case glibExcepionType_GLIB_PARSE_BadCode:return "GLIBS[PARSE]: Bad Code."; 
	case glibExcepionType_GLIB_PARSE_VersionMismatch:return "GLIBS[PARSE]: Version Mismatch."; 
	case glibExcepionType_GLIB_PARSE_EndianMismatch:return "GLIBS[PARSE]: Endian Mismatch."; 
	case glibExcepionType_GLIB_PARSE_Accessrights:return "GLIBS[PARSE]: Accessright Exception."; 
	case glibExcepionType_GLIB_PARSE_WrongPassword:return "GLIBS[PARSE]: Wrong password."; 


	// Kernel		  
	case glibExcepionType_GLIB_KERNEL_GeneralTrouble:return "GLIBS[KERNEL]: General Kernel Trouble."; 
	case glibExcepionType_GLIB_KERNEL_WindowsSuxx:return "GLIBS[KERNEL]: M$ WINDOOF SUXX Exception (Windows version of OsTrouble Exception)."; 
	case glibExcepionType_GLIB_KERNEL_OSTrouble:return "GLIBS[KERNEL]: Os Trouble Exception."; 
	case glibExcepionType_GLIB_KERNEL_ConfigfileNotFound:return "GLIBS[KERNEL]: Kernel Config file missing."; 
	case glibExcepionType_GLIB_KERNEL_MutexNotFound:return "GLIBS[KERNEL]: Mutex was missing."; 
	case glibExcepionType_GLIB_KERNEL_MutexNotAllocatable:return "GLIBS[KERNEL]: Could not allocate Mutex."; 

	case glibExcepionType_GLIB_KERNEL_TooManyLogClasses:return "GLIBS[KERNEL]: Too many logger classes are specified. Maximum is 16."; 
	case glibExcepionType_GLIB_KERNEL_TooManyLogDrains:return "GLIBS[KERNEL]: Too many log drains are specified. Maximum is 16."; 
	case glibExcepionType_GLIB_KERNEL_IdentifierTooLong:return "GLIBS[KERNEL]: A used name identifier was too long. Max is normally 15 or 31."; 
	case glibExcepionType_GLIB_KERNEL_LogDrainClassNotFound:return "GLIBS[KERNEL]: A specified logging drain class (in glibs.config) was not found. "; 

	case glibExcepionType_GLIB_KERNEL_OutOfMemory:return "GLIBS[KERNEL]: Out of Memory Exception."; 


	// Plugin manager		  
	case glibExcepionType_GLIB_PLUGINS_UnknownIdentifier:return "GLIBS[PLUGIN]: Factory class Identifier unknown."; 
	case glibExcepionType_GLIB_PLUGINS_ClusterNotFound:return "GLIBS[PLUGIN]: Could not locate plaugi cluster for class."; 
	case glibExcepionType_GLIB_PLUGINS_PluginNotFound:return "GLIBS[PLUGIN]: Plugin for class identifier not found."; 
	case glibExcepionType_GLIB_PLUGINS_MinimumCriteria:return "GLIBS[PLUGIN]: No Plugin which meets the minimum criteria of System."; 
	case glibExcepionType_GLIB_PLUGINS_MaximumCriteria:return "GLIBS[PLUGIN]: No Plugin which meets the required minimum criteria."; 
	case glibExcepionType_GLIB_PLUGINS_FileNotFound:return "GLIBS[PLUGIN]: Plugin file (*.library or *.dll) not found."; 
	case glibExcepionType_GLIB_PLUGINS_LoadError:return "GLIBS[PLUGIN]: Plugin was found, but could not be loaded. Check dependencies !"; 


	// Platform  
	case glibExcepionType_GLIB_PLATFORM_IntervalTimer:return "GLIBS[PLATFORM]: General interval timer exception (Assert replacement)."; 
	case glibExcepionType_GLIB_PLATFORM_NoRunnableInterface:return "GLIBS[PLATFORM]: Runnable interface is NULL. Need interface to run thread."; 


	//$$%%$$%%pattern<<<< 
	};

	return "Illegal Exception .... ";

}

///////////////////////////////////////////////////////////////////////////////////////////////////
/*!	\fn          glibPlatformException::Win32_To_Glibs(DWORD dwExceptionCode) 
*	
*   \param       DWORD dwExceptionCode
*   \return      glibExcepionType 
*   \note        
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
glibExcepionType glibPlatformException::Win32_To_Glibs(DWORD dwExceptionCode)
{
	switch(dwExceptionCode) {

	// Another example of a substitution region

	//$$%%$$%%pattern>>>> exceptions win2glib
	//---------------------------------------------------------------------------------------------
	// Section: Special purpose  
	//---------------------------------------------------------------------------------------------

	// special  
	case 0xffffffff : return glibExcepionType_UNKNOWN; break; 
	case 0xe1000001 : return glibExcepionType_Reraised; break; 
	case 0xe06d7363 : return glibExcepionType_MS_VCPP_THROW; break; 


	//---------------------------------------------------------------------------------------------
	// Section: Hardware exceptions  
	//---------------------------------------------------------------------------------------------

	// Memory  
	case STATUS_ACCESS_VIOLATION : return glibExcepionType_MEM_AccessViolation; break; 
	case STATUS_DATATYPE_MISALIGNMENT : return glibExcepionType_MEM_MisalignedAccess; break; 


	// Arithmetic		  
	case STATUS_INTEGER_DIVIDE_BY_ZERO : return glibExcepionType_ARITH_DivisionByZero; break; 
	case STATUS_INTEGER_OVERFLOW : return glibExcepionType_ARITH_Overflow; break; 


	// Instruction set		  
	case STATUS_ILLEGAL_INSTRUCTION : return glibExcepionType_CPU_IllegalInstruction; break; 
	case STATUS_PRIVILEGED_INSTRUCTION : return glibExcepionType_CPU_PrivilegedInstruction; break; 


	// Debugging		  
	case STATUS_BREAKPOINT : return glibExcepionType_DEBUG_Breakpoint; break; 
	case STATUS_SINGLE_STEP : return glibExcepionType_DEBUG_Singlestep; break; 


	//---------------------------------------------------------------------------------------------
	// Section: Glibs		  
	//---------------------------------------------------------------------------------------------

	// Memory  
	case 0xe1000002 : return glibExcepionType_GLIB_MEM_OutOfMemory; break; 
	case 0xe1000003 : return glibExcepionType_GLIB_MEM_NullpointerAtDelete; break; 
	case 0xe1000004 : return glibExcepionType_GLIB_MEM_ConstructionOfNullObj; break; 
	case 0xe1000005 : return glibExcepionType_GLIB_MEM_DeletingNullObj; break; 
	case 0xe1000006 : return glibExcepionType_GLIB_MEM_WrongAlignment; break; 
	case 0xe1000007 : return glibExcepionType_GLIB_MEM_MemCategoryNotLocked; break; 
	case 0xe1000008 : return glibExcepionType_GLIB_MEM_FileInfoStackOverflow; break; 
	case 0xe1000009 : return glibExcepionType_GLIB_MEM_FileInfoStackUnderflow; break; 


	// Thread management		  
	case 0xe2000001 : return glibExcepionType_GLIB_THREAD_IllegalThreadId; break; 
	case 0xe2000002 : return glibExcepionType_GLIB_THREAD_NoMutex; break; 
	case 0xe2000003 : return glibExcepionType_GLIB_THREAD_InterfaceMissing; break; 


	// Logger		  
	case 0xe4000001 : return glibExcepionType_GLIB_LOGGER_IllegalCall; break; 
	case 0xe4000002: return glibExcepionType_GLIB_LOGGER_ContextNotFound; break; 
	case 0xe4000003 : return glibExcepionType_GLIB_LOGGER_ContextStackOverflow; break; 
	case 0xe4000004 : return glibExcepionType_GLIB_LOGGER_ContextStackUnderflow; break; 


	// Debugging		  
	case 0xe5000001 : return glibExcepionType_GLIB_DEBUG_AssertionFailed; break; 
	case 0xe5000002 : return glibExcepionType_GLIB_DEBUG_Error; break; 
	case 0xe5000003 : return glibExcepionType_GLIB_DEBUG_Warning; break; 
	case 0xe5000004 : return glibExcepionType_GLIB_DEBUG_Info; break; 
	case 0xe5000005 : return glibExcepionType_GLIB_DEBUG_Note; break; 
	case 0xe5000006 : return glibExcepionType_GLIB_DEBUG_Message; break; 
	case 0xe5000007 : return glibExcepionType_GLIB_DEBUG_FailAssert; break; 


	// File System		  
	case 0xe6000001 : return glibExcepionType_GLIB_FILE_CannotOpen; break; 
	case 0xe6000002 : return glibExcepionType_GLIB_FILE_UnexceptedEnd; break; 
	case 0xe6000003 : return glibExcepionType_GLIB_FILE_FormatError; break; 


	// Parser		  
	case 0xe7000001 : return glibExcepionType_GLIB_PARSE_Error; break; 
	case 0xe7000002 : return glibExcepionType_GLIB_PARSE_Warning; break; 
	case 0xe7000003 : return glibExcepionType_GLIB_PARSE_BadFormat; break; 
	case 0xe7000004 : return glibExcepionType_GLIB_PARSE_BadTag; break; 
	case 0xe7000005 : return glibExcepionType_GLIB_PARSE_BadCode; break; 
	case 0xe7000006 : return glibExcepionType_GLIB_PARSE_VersionMismatch; break; 
	case 0xe7000007 : return glibExcepionType_GLIB_PARSE_EndianMismatch; break; 
	case 0xe7000008 : return glibExcepionType_GLIB_PARSE_Accessrights; break; 
	case 0xe7000009 : return glibExcepionType_GLIB_PARSE_WrongPassword; break; 


	// Kernel		  
	case 0xe8000001 : return glibExcepionType_GLIB_KERNEL_GeneralTrouble; break; 
	case 0xe8000002 : return glibExcepionType_GLIB_KERNEL_WindowsSuxx; break; 
	case 0xe8000003 : return glibExcepionType_GLIB_KERNEL_OSTrouble; break; 
	case 0xe8000004 : return glibExcepionType_GLIB_KERNEL_ConfigfileNotFound; break; 
	case 0xe8000005 : return glibExcepionType_GLIB_KERNEL_MutexNotFound; break; 
	case 0xe8000006 : return glibExcepionType_GLIB_KERNEL_MutexNotAllocatable; break; 

	case 0xe8000007 : return glibExcepionType_GLIB_KERNEL_TooManyLogClasses; break; 
	case 0xe8000008 : return glibExcepionType_GLIB_KERNEL_TooManyLogDrains; break; 
	case 0xe8000009 : return glibExcepionType_GLIB_KERNEL_IdentifierTooLong; break; 
	case 0xe800000a : return glibExcepionType_GLIB_KERNEL_LogDrainClassNotFound; break; 

	case 0xe800000b : return glibExcepionType_GLIB_KERNEL_OutOfMemory; break; 


	// Plugin manager		  
	case 0xe9000001 : return glibExcepionType_GLIB_PLUGINS_UnknownIdentifier; break; 
	case 0xe9000002 : return glibExcepionType_GLIB_PLUGINS_ClusterNotFound; break; 
	case 0xe9000003 : return glibExcepionType_GLIB_PLUGINS_PluginNotFound; break; 
	case 0xe9000004 : return glibExcepionType_GLIB_PLUGINS_MinimumCriteria; break; 
	case 0xe9000005 : return glibExcepionType_GLIB_PLUGINS_MaximumCriteria; break; 
	case 0xe9000006 : return glibExcepionType_GLIB_PLUGINS_FileNotFound; break; 
	case 0xe9000007 : return glibExcepionType_GLIB_PLUGINS_LoadError; break; 


	// Platform  
	case 0xeb000001 : return glibExcepionType_GLIB_PLATFORM_IntervalTimer; break; 
	case 0xeb000002 : return glibExcepionType_GLIB_PLATFORM_NoRunnableInterface; break; 


	//$$%%$$%%pattern<<<<
	
	default:
		return glibExcepionType_UNKNOWN;
	}
	
	return glibExcepionType_UNKNOWN;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
/*!	\fn          glibPlatformException::Win32_To_Glibs(glibExcepionType  eExceptionCode) 
*	
*   \param       glibExcepionType  eExceptionCode
*   \return      DWORD 
*   \note        
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD glibPlatformException::Glibs_To_Win32(glibExcepionType  eExceptionCode)
{
	switch(eExceptionCode) {
	
	// And a third example

	//$$%%$$%%pattern>>>> exceptions glib2win
	//---------------------------------------------------------------------------------------------
	// Section: Special purpose  
	//---------------------------------------------------------------------------------------------

	// special  
	case glibExcepionType_UNKNOWN: 
		return 0xffffffff ; 
		break; 
	case glibExcepionType_Reraised: 
		return 0xe1000001 ; 
		break;  
	case glibExcepionType_MS_VCPP_THROW: 
		return 0xe06d7363 ; 
		break;  


	//---------------------------------------------------------------------------------------------
	// Section: Hardware exceptions  
	//---------------------------------------------------------------------------------------------

	// Memory  
	case glibExcepionType_MEM_AccessViolation: 
		return STATUS_ACCESS_VIOLATION ; 
		break; 
	case glibExcepionType_MEM_MisalignedAccess: 
		return STATUS_DATATYPE_MISALIGNMENT ; 
		break;  


	// Arithmetic		  
	case glibExcepionType_ARITH_DivisionByZero: 
		return STATUS_INTEGER_DIVIDE_BY_ZERO ; 
		break;  
	case glibExcepionType_ARITH_Overflow: 
		return STATUS_INTEGER_OVERFLOW ; 
		break;  


	// Instruction set		  
	case glibExcepionType_CPU_IllegalInstruction: 
		return STATUS_ILLEGAL_INSTRUCTION ; 
		break;  
	case glibExcepionType_CPU_PrivilegedInstruction: 
		return STATUS_PRIVILEGED_INSTRUCTION ; 
		break;  


	// Debugging		  
	case glibExcepionType_DEBUG_Breakpoint: 
		return STATUS_BREAKPOINT ; 
		break;  
	case glibExcepionType_DEBUG_Singlestep: 
		return STATUS_SINGLE_STEP ; 
		break;  


	//---------------------------------------------------------------------------------------------
	// Section: Glibs		  
	//---------------------------------------------------------------------------------------------

	// Memory  
	case glibExcepionType_GLIB_MEM_OutOfMemory: 
		return 0xe1000002 ; 
		break;  
	case glibExcepionType_GLIB_MEM_NullpointerAtDelete: 
		return 0xe1000003 ; 
		break;  
	case glibExcepionType_GLIB_MEM_ConstructionOfNullObj: 
		return 0xe1000004 ; 
		break;  
	case glibExcepionType_GLIB_MEM_DeletingNullObj: 
		return 0xe1000005 ; 
		break;  
	case glibExcepionType_GLIB_MEM_WrongAlignment: 
		return 0xe1000006 ; 
		break;  
	case glibExcepionType_GLIB_MEM_MemCategoryNotLocked: 
		return 0xe1000007 ; 
		break;  
	case glibExcepionType_GLIB_MEM_FileInfoStackOverflow: 
		return 0xe1000008 ; 
		break;  
	case glibExcepionType_GLIB_MEM_FileInfoStackUnderflow: 
		return 0xe1000009 ; 
		break;  


	// Thread management		  
	case glibExcepionType_GLIB_THREAD_IllegalThreadId: 
		return 0xe2000001 ; 
		break;  
	case glibExcepionType_GLIB_THREAD_NoMutex: 
		return 0xe2000002 ; 
		break;  
	case glibExcepionType_GLIB_THREAD_InterfaceMissing: 
		return 0xe2000003 ; 
		break;  


	// Logger		  
	case glibExcepionType_GLIB_LOGGER_IllegalCall: 
		return 0xe4000001 ; 
		break;  
	case glibExcepionType_GLIB_LOGGER_ContextNotFound: 
		return 0xe4000002; 
		break;  
	case glibExcepionType_GLIB_LOGGER_ContextStackOverflow: 
		return 0xe4000003 ; 
		break;  
	case glibExcepionType_GLIB_LOGGER_ContextStackUnderflow: 
		return 0xe4000004 ; 
		break;  


	// Debugging		  
	case glibExcepionType_GLIB_DEBUG_AssertionFailed: 
		return 0xe5000001 ; 
		break;  
	case glibExcepionType_GLIB_DEBUG_Error: 
		return 0xe5000002 ; 
		break;  
	case glibExcepionType_GLIB_DEBUG_Warning: 
		return 0xe5000003 ; 
		break;  
	case glibExcepionType_GLIB_DEBUG_Info: 
		return 0xe5000004 ; 
		break;  
	case glibExcepionType_GLIB_DEBUG_Note: 
		return 0xe5000005 ; 
		break;  
	case glibExcepionType_GLIB_DEBUG_Message: 
		return 0xe5000006 ; 
		break;  
	case glibExcepionType_GLIB_DEBUG_FailAssert: 
		return 0xe5000007 ; 
		break;  


	// File System		  
	case glibExcepionType_GLIB_FILE_CannotOpen: 
		return 0xe6000001 ; 
		break;  
	case glibExcepionType_GLIB_FILE_UnexceptedEnd: 
		return 0xe6000002 ; 
		break;  
	case glibExcepionType_GLIB_FILE_FormatError: 
		return 0xe6000003 ; 
		break;  


	// Parser		  
	case glibExcepionType_GLIB_PARSE_Error: 
		return 0xe7000001 ; 
		break;  
	case glibExcepionType_GLIB_PARSE_Warning: 
		return 0xe7000002 ; 
		break;  
	case glibExcepionType_GLIB_PARSE_BadFormat: 
		return 0xe7000003 ; 
		break;  
	case glibExcepionType_GLIB_PARSE_BadTag: 
		return 0xe7000004 ; 
		break;  
	case glibExcepionType_GLIB_PARSE_BadCode: 
		return 0xe7000005 ; 
		break;  
	case glibExcepionType_GLIB_PARSE_VersionMismatch: 
		return 0xe7000006 ; 
		break;  
	case glibExcepionType_GLIB_PARSE_EndianMismatch: 
		return 0xe7000007 ; 
		break;  
	case glibExcepionType_GLIB_PARSE_Accessrights: 
		return 0xe7000008 ; 
		break;  
	case glibExcepionType_GLIB_PARSE_WrongPassword: 
		return 0xe7000009 ; 
		break;  


	// Kernel		  
	case glibExcepionType_GLIB_KERNEL_GeneralTrouble: 
		return 0xe8000001 ; 
		break;  
	case glibExcepionType_GLIB_KERNEL_WindowsSuxx: 
		return 0xe8000002 ; 
		break;  
	case glibExcepionType_GLIB_KERNEL_OSTrouble: 
		return 0xe8000003 ; 
		break;  
	case glibExcepionType_GLIB_KERNEL_ConfigfileNotFound: 
		return 0xe8000004 ; 
		break;  
	case glibExcepionType_GLIB_KERNEL_MutexNotFound: 
		return 0xe8000005 ; 
		break;  
	case glibExcepionType_GLIB_KERNEL_MutexNotAllocatable: 
		return 0xe8000006 ; 
		break;  

	case glibExcepionType_GLIB_KERNEL_TooManyLogClasses: 
		return 0xe8000007 ; 
		break;  
	case glibExcepionType_GLIB_KERNEL_TooManyLogDrains: 
		return 0xe8000008 ; 
		break;  
	case glibExcepionType_GLIB_KERNEL_IdentifierTooLong: 
		return 0xe8000009 ; 
		break;  
	case glibExcepionType_GLIB_KERNEL_LogDrainClassNotFound: 
		return 0xe800000a ; 
		break;  

	case glibExcepionType_GLIB_KERNEL_OutOfMemory: 
		return 0xe800000b ; 
		break;  


	// Plugin manager		  
	case glibExcepionType_GLIB_PLUGINS_UnknownIdentifier: 
		return 0xe9000001 ; 
		break;  
	case glibExcepionType_GLIB_PLUGINS_ClusterNotFound: 
		return 0xe9000002 ; 
		break;  
	case glibExcepionType_GLIB_PLUGINS_PluginNotFound: 
		return 0xe9000003 ; 
		break;  
	case glibExcepionType_GLIB_PLUGINS_MinimumCriteria: 
		return 0xe9000004 ; 
		break;  
	case glibExcepionType_GLIB_PLUGINS_MaximumCriteria: 
		return 0xe9000005 ; 
		break;  
	case glibExcepionType_GLIB_PLUGINS_FileNotFound: 
		return 0xe9000006 ; 
		break;  
	case glibExcepionType_GLIB_PLUGINS_LoadError: 
		return 0xe9000007 ; 
		break;  


	// Platform  
	case glibExcepionType_GLIB_PLATFORM_IntervalTimer: 
		return 0xeb000001 ; 
		break;  
	case glibExcepionType_GLIB_PLATFORM_NoRunnableInterface: 
		return 0xeb000002 ; 
		break; 


	//$$%%$$%%pattern<<<<
	default:
		return 0xffffffff;
	}
	
	return 0xffffffff;	

}

